//+------------------------------------------------------------------+
//|                            Divergence_for_Many_Indicators_v4.mq4 |
//|                        Copyright 2021, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 8

#property  indicator_type7 DRAW_NONE
#property  indicator_label7 "Buy"
#property  indicator_type8 DRAW_NONE
#property  indicator_label8 "Sell"

enum Divergence_Type
  {
   Regular,
   Hidden,
   R_H     //Regular/Hidden
  };

enum Indi_Name
  {
   Full,
   First,    //First Letter
   DonotShow     //Don't Show
  };
int         max_bars_back      =1000;
int         max_lines_count    =400;
int         max_labels_count   =400;
input  int                  prd       = 5;         //Pivot Period
input  ENUM_APPLIED_PRICE   source    = PRICE_CLOSE;//Source for Pivot Points
input  Divergence_Type      searchdiv = Regular;    //Divergence Type
input  Indi_Name            showindis = Full;       //Show Indicator Names
input  int                  showlimit = 1;          //Minimum Number of Divergence
input  int                  maxpp     = 10;        //Maximum Pivot Points to Check
input  int                  maxbars   = 100;       //Maximum Bars to Check
input  bool                 shownum   = true;      //Show Divergence Number
input  bool                 showlast  = false;     //Show Only Last Divergence
input  bool                 dontconfirm=false;     //Don't Wait for Confirmation
input  bool                 showlines = true;     //Show Divergence Lines
input  bool                 showpivot = false;    //Show Pivot Points
input  bool                 calcmacd  = true;     //MACD
input  bool                 calcmacda = true;     //MACD Histogram
input  bool                 calcrsi   = true;     //RSI
input  bool                 calcstoc  = true;     //Stochastic
input  bool                 calccci   = true;     //CCI
input  bool                 calcmom   = true;     //Momentum
input  bool                 calcobv   = true;     //OBV
input  bool                 calcvwmacd= true;     //VWmacd
input  bool                 calccmf   = true;     //Chaikin Money Flow
input  bool                 calcmfi   = true;     //Money Flow Index
input  bool                 calcext   = false;    //Check External Indicator
input  ENUM_APPLIED_PRICE   externalindi    = PRICE_CLOSE; // External Indicator
input  color                pos_reg_div_col = clrYellow;   // Positive Regular Divergence
input  color                neg_reg_div_col = clrAqua;     // Negative Regular Divergence
input  color                pos_hid_div_col = clrMediumSpringGreen;     // Positive Hidden Divergence
input  color                neg_hid_div_col = clrRed;      // Negative Hidden Divergence
input  color                pos_div_text_col= clrBlack;    // Positive Divergence Text Color
input  color                neg_div_text_col= clrWhite;    // Negative Divergence Text Color
input  ENUM_LINE_STYLE      reg_div_l_style= STYLE_SOLID; // Regular Divergence Line Style
input  ENUM_LINE_STYLE      hid_div_l_style= STYLE_DASH;  // Hidden Divergence Line Style
input  int                  reg_div_l_width = 2;           // Regular Divergence Line Width
input  int                  hid_div_l_width = 1;           // Hidden Divergence Line Width




double rsi[],macd[],signal[], deltamacd[],moment[],cci[],signgroup[],Obv[],stochgroup[],stk[];
double maFast[],maSlow[],vwmacd[],Cmfm[],Cmfv[],cmf[],Mfi[],VolumeData[];
string indicators_name[11];
color  div_colors[4];
double test[],test1[],test2[];
double prscP[],prscN[];

string Basename="ffss";

int maxarraysize = 20;
int ph_positions[20],pl_positions[20];
double ph_vals[20],pl_vals[20];

int all_divergences[44];
double external[];

int pos_line_index=0;
int neg_line_index=0;
int pos_label_index=0;
int neg_label_index=0;

int last_pos_div_lines = 0;
int last_neg_div_lines = 0;
bool remove_last_pos_divs = false;
bool remove_last_neg_divs = false;

string pos_div_lines[],neg_div_lines[],pos_div_labels[],neg_div_labels[];


double ExpBuy[];
double ExpSell[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   ArrayInitialize(rsi, EMPTY_VALUE);
   ArrayInitialize(macd, EMPTY_VALUE);
   ArrayInitialize(signal, EMPTY_VALUE);
   ArrayInitialize(deltamacd, EMPTY_VALUE);
   ArrayInitialize(moment, EMPTY_VALUE);
   ArrayInitialize(cci, EMPTY_VALUE);
   ArrayInitialize(signgroup, EMPTY_VALUE);
   ArrayInitialize(Obv, EMPTY_VALUE);
   ArrayInitialize(stochgroup, EMPTY_VALUE);
   ArrayInitialize(stk, EMPTY_VALUE);
   ArrayInitialize(maFast, EMPTY_VALUE);
   ArrayInitialize(maSlow, EMPTY_VALUE);
   ArrayInitialize(vwmacd, EMPTY_VALUE);
   ArrayInitialize(Cmfm, EMPTY_VALUE);
   ArrayInitialize(Cmfv, EMPTY_VALUE);
   ArrayInitialize(cmf, EMPTY_VALUE);
   ArrayInitialize(Mfi, EMPTY_VALUE);
   ArrayInitialize(VolumeData, EMPTY_VALUE);


   SetIndexBuffer(0,test);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2,clrRed);
   SetIndexLabel(0,"TEST");
   SetIndexEmptyValue(0,0.0);
   ArrayInitialize(test,EMPTY_VALUE);

   SetIndexBuffer(1,test1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2,clrBlue);
   SetIndexLabel(1,"TEST1");
   SetIndexEmptyValue(0,0.0);
   ArrayInitialize(test1,EMPTY_VALUE);

   SetIndexBuffer(2,test2);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2,clrGreen);
   SetIndexLabel(2,"TEST2");
   SetIndexEmptyValue(0,0.0);
   ArrayInitialize(test2,EMPTY_VALUE);

   SetIndexBuffer(3,prscP);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexLabel(3,"prscP");
   SetIndexEmptyValue(0,0.0);
   ArrayInitialize(prscP,EMPTY_VALUE);

   SetIndexBuffer(4,prscN);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexLabel(4,"prscN");
   SetIndexEmptyValue(0,0.0);
   ArrayInitialize(prscN,EMPTY_VALUE);

   SetIndexBuffer(5,external);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexLabel(5,"external");
   SetIndexEmptyValue(0,0.0);
   ArrayInitialize(external,EMPTY_VALUE);


   indicators_name[0]= showindis == Full ? "MACD" : "M";
   indicators_name[1]= showindis == Full ? "Hist" : "H";
   indicators_name[2]= showindis == Full ? "RSI" : "E";
   indicators_name[3]= showindis == Full ? "Stoch" : "S";
   indicators_name[4]= showindis == Full ? "CCI" : "C";
   indicators_name[5]= showindis == Full ? "MOM" : "M";
   indicators_name[6]= showindis == Full ? "OBV" : "O";
   indicators_name[7]= showindis == Full ? "VWMACD" : "V";
   indicators_name[8]= showindis == Full ? "CMF" : "C";
   indicators_name[9]= showindis == Full ? "MFI" : "M";
   indicators_name[10]= showindis == Full ? "Extrn" : "X";

   div_colors[0]=pos_reg_div_col;
   div_colors[1]=neg_reg_div_col;
   div_colors[2]=pos_hid_div_col;
   div_colors[3]=neg_hid_div_col;



   ArrayInitialize(ph_positions,0);
   ArrayInitialize(pl_positions,0);
   ArrayInitialize(ph_vals,0);
   ArrayInitialize(pl_vals,0);

   ArrayInitialize(all_divergences,0);

   ArrayResize(pos_div_lines,1);
   ArrayResize(neg_div_lines,1);
   ArrayResize(pos_div_labels,1);
   ArrayResize(neg_div_labels,1);


   SetIndexBuffer(6,ExpBuy);
   SetIndexBuffer(7,ExpSell);
   ArraySetAsSeries(ExpBuy, EMPTY_VALUE);
   ArraySetAsSeries(ExpSell, EMPTY_VALUE);

//ArrayResize(distances,1);

//---
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void array_set_divs(int &div_pointer[], int index)
  {
   for(int x=0; x<=3; x++)
     {
      all_divergences[index * 4 + x] = div_pointer[x];
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void NewArray(int totals)
  {
   ResizeBuffer(rsi, totals);
   ResizeBuffer(macd, totals);
   ResizeBuffer(signal, totals);
   ResizeBuffer(deltamacd, totals);
   ResizeBuffer(moment, totals);
   ResizeBuffer(signgroup, totals);
   ResizeBuffer(Obv, totals);
   ResizeBuffer(cci, totals);
   ResizeBuffer(stochgroup, totals);
   ResizeBuffer(stk, totals);
   ResizeBuffer(maFast, totals);
   ResizeBuffer(maSlow, totals);
   ResizeBuffer(vwmacd, totals);
   ResizeBuffer(Cmfm, totals);
   ResizeBuffer(Cmfv, totals);
   ResizeBuffer(cmf, totals);
   ResizeBuffer(Mfi, totals);
   ResizeBuffer(VolumeData, totals);



  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int limit;
   limit = rates_total-prev_calculated - 1;
   if(rates_total == prev_calculated)
      limit = 0;

   if(limit >= 0)
      NewArray(rates_total);

   for(int i = limit; i >= 0; i--)
     {
      if(i > Bars - 50)
         continue;
      Process(i);
     }




//--- return value of prev_calculated for next call
   return(rates_total);
  }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ResizeBuffer(double& buffer[], int size)
  {
   if(ArrayRange(buffer,0) != size)            // ArrayRange allows 1D or 2D arrays
     {
      ArraySetAsSeries(buffer, false);    // Shift values B[2]=B[1]; B[1]=B[0]
      if(ArrayResize(buffer, size) <= 0)
        {
         return(false);
        }
      ArraySetAsSeries(buffer, true);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ArrayInclud(double & array[], double value)
  {
   for(int i=0; i<ArraySize(array); i++)
     {
      if(array[i]==value)
         return true;
     }

   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ArrayPush(double & array[], double value)
  {
   int index=ArraySize(array)-1;
   array[index]=value;
   ArrayResize(array,index+2);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ArrayPush(string & array[], string value)
  {
   int index=ArraySize(array)-1;
   array[index]=value;
   ArrayResize(array,index+2);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Process(int i)
  {
//ArrayInitialize(all_divergences,0);
   external[i]=Price(externalindi,i);
   if(source == PRICE_CLOSE)
     {
      prscP[i]=Close[i];
      prscN[i]=Close[i];
     }
   else
     {
      prscP[i]=Low[i];
      prscN[i]=High[i];
     }

   rsi[i]=iRSI(_Symbol,0,14,PRICE_CLOSE,i);
   macd[i]=iMACD(_Symbol,0,12,26,9,PRICE_CLOSE,0,i);
   signal[i]=iMACD(_Symbol,0,12,26,9,PRICE_CLOSE,1,i);
   deltamacd[i]=macd[i]-signal[i];
   moment[i]=Close[i]-Close[i+10];
   cci[i]=iCCI(_Symbol,0,10,PRICE_CLOSE,i);

   long volume = iVolume(_Symbol,_Period,i);

   VolumeData[i] =(double) volume;
   signgroup[i]=Sign(Close[i]-Close[i+1])*volume;
   Obv[i]=Cum(signgroup);
   stochgroup[i]=Stoch(14,i);
   stk[i]=SimpleMA(i,3,stochgroup);

   maFast[i] = VolumnWeightMA(i,12,Close);
   maSlow[i] = VolumnWeightMA(i,26,Close);
   vwmacd[i] =  maFast[i]- maSlow[i];

   if(High[i]!=Low[i])
      Cmfm[i] = ((Close[i]-Low[i]) - (High[i]-Close[i])) / (High[i] - Low[i]);
   else
      Cmfm[i] =EMPTY_VALUE;
   Cmfv[i] = Cmfm[i] * volume;
   cmf[i] =SimpleMA(i,21,Cmfv) / SimpleMA(i,21,VolumeData); // Chaikin money flow
   Mfi[i] =iMFI(_Symbol,0,14,i);

   double ph=0.0,pl=0.0;
   if(source==PRICE_CLOSE)
     {
      ph=PivotHigh(Close,prd,prd,i);
      pl=PivotLow(Close,prd,prd,i);
     }
   else
     {
      ph=PivotHigh(High,prd,prd,i);
      pl=PivotLow(Low,prd,prd,i);
     }

   string txt=Basename+" H "+TimeToString(iTime(_Symbol,PERIOD_CURRENT,i),TIME_DATE|TIME_MINUTES);
   if(ObjectFind(0,txt)>=0)
      ObjectDelete(0,txt);
   if(ph!=DBL_MAX && showpivot && ObjectFind(0,txt)<0)
      TextCreate(0,txt,0,Time[i+prd],High[i+prd],"H",clrRed,ANCHOR_LEFT_LOWER);

   txt=Basename+" L "+TimeToString(iTime(_Symbol,PERIOD_CURRENT,i),TIME_DATE|TIME_MINUTES);
   if(ObjectFind(0,txt)>=0)
      ObjectDelete(0,txt);
   if(pl!=DBL_MAX && showpivot && ObjectFind(0,txt)<0)
      TextCreate(0,txt,0,Time[i+prd],Low[i+prd],"L",clrBlue);


   if(ph!=DBL_MAX)
     {
      UnShift(ph_positions,Bars-i-1);
      UnShift(ph_vals,ph);
     }
   if(pl!=DBL_MAX)
     {
      UnShift(pl_positions,Bars-i-1);
      UnShift(pl_vals,pl);
     }


   int result0[4];
   ArrayInitialize(result0,0);
   calculate_divs(calcmacd, macd,result0,i);
   array_set_divs(result0,0);

   ArrayInitialize(result0,0);
   calculate_divs(calcmacda, deltamacd,result0,i);
   array_set_divs(result0,1);

   ArrayInitialize(result0,0);
   calculate_divs(calcrsi, rsi,result0,i);
   array_set_divs(result0,2);

   ArrayInitialize(result0,0);
   calculate_divs(calcstoc, stk,result0,i);
   array_set_divs(result0,3);

   ArrayInitialize(result0,0);
   calculate_divs(calccci, cci,result0,i);
   array_set_divs(result0,4);

   ArrayInitialize(result0,0);
   calculate_divs(calcmom, moment,result0,i);
   array_set_divs(result0,5);

   ArrayInitialize(result0,0);
   calculate_divs(calcobv, Obv,result0,i);
   array_set_divs(result0,6);

   ArrayInitialize(result0,0);
   calculate_divs(calcvwmacd, vwmacd,result0,i);
   array_set_divs(result0,7);

   ArrayInitialize(result0,0);
   calculate_divs(calccmf, cmf,result0,i);
   array_set_divs(result0,8);

   ArrayInitialize(result0,0);
   calculate_divs(calcmfi, Mfi,result0,i);
   array_set_divs(result0,9);

   ArrayInitialize(result0,0);
   calculate_divs(calcext, external,result0,i);
   array_set_divs(result0,10);



   double total_div = 0;
   for(int x=0; x<ArraySize(all_divergences); x++)
      total_div = total_div + round(Sign(all_divergences[x]));

   if(total_div < showlimit)
      ArrayFill(all_divergences,0,ArraySize(all_divergences),0);

//test2[i]=(double)all_divergences[2];
//test1[i]=(double)all_divergences[3];

   bool pos_reg_div_detected = false;
   bool neg_reg_div_detected = false;
   bool pos_hid_div_detected = false;
   bool neg_hid_div_detected = false;



   if(pl!=DBL_MAX)
     {
      remove_last_pos_divs = false;
      last_pos_div_lines = 0;
     }
   if(ph!=DBL_MAX)
     {
      remove_last_neg_divs = false;
      last_neg_div_lines = 0;
     }
   string divergence_text_top = "";
   string divergence_text_bottom = "";

   double distances[];
   ArrayResize(distances,1);

   int dnumdiv_top = 0;
   int dnumdiv_bottom = 0;
   color top_label_col = clrWhite;
   color bottom_label_col = clrWhite;
   bool old_pos_divs_can_be_removed = true;
   bool old_neg_divs_can_be_removed = true;
   int  startpoint = dontconfirm ? 0 : 1;

   for(int x=0; x<=10; x++)
     {
      int div_type = -1;
      for(int y=0; y<=3; y++)
        {
         if(all_divergences[x * 4 + y] > 0)  // any divergence
           {
            div_type = y;
            if((y % 2) == 1)
              {
               dnumdiv_top = dnumdiv_top + 1;
               top_label_col = div_colors[y];
              }
            if((y % 2) == 0)
              {
               dnumdiv_bottom = dnumdiv_bottom + 1;
               bottom_label_col = div_colors[y];
              }
            if(!ArrayInclud(distances,all_divergences[x * 4 + y]))
              {
               ArrayPush(distances,all_divergences[x * 4 + y]);
               int bar_index=Bars-i-1;
               int x1=bar_index-all_divergences[x * 4 + y];
               double y1 = source == PRICE_CLOSE ? Close[all_divergences[x * 4 + y]+i] : y == 0 || y == 3 ? Low [all_divergences[x * 4 + y]+i] :  High[all_divergences[x * 4 + y]+i];
               int x2 = bar_index - startpoint;
               double y2 = source == PRICE_CLOSE ? Close[startpoint+i] : y == 0 || y == 3  ? Low[startpoint+i] : High[startpoint+i];
               color _color=div_colors[y];
               ENUM_LINE_STYLE style = y < 2 ? reg_div_l_style : hid_div_l_style;
               int width = y < 2 ? reg_div_l_width : hid_div_l_width;

               if(all_divergences[x * 4 + y]+i==241)
                  int stop=100;
               string trendLine="";
               if((y % 2) == 0)
                  trendLine=Basename+" PLine "+IntegerToString(bar_index)+":"+IntegerToString(all_divergences[x * 4 + y]+i)+"-"+IntegerToString(startpoint+i)+"("+TimeToString(TimeCurrent())+")"+IntegerToString(ArraySize(pos_div_lines));
               if((y % 2) == 1)
                  trendLine=Basename+" NLine "+IntegerToString(bar_index)+":"+IntegerToString(all_divergences[x * 4 + y]+i)+"-"+IntegerToString(startpoint+i)+"("+TimeToString(TimeCurrent())+")"+IntegerToString(ArraySize(neg_div_lines));

               if(showlines)
                 {
                  if(! TrendCreate(0,trendLine,0,Time[all_divergences[x * 4 + y]+i],y1,Time[startpoint+i],y2,_color,style,width))
                     continue;
                 }

               if((y % 2) == 0)
                 {
                  if(old_pos_divs_can_be_removed)
                    {
                     old_pos_divs_can_be_removed = false;
                     if(! showlast && remove_last_pos_divs)
                       {
                        delete_last_pos_div_lines_label(last_pos_div_lines);
                        last_pos_div_lines = 0;

                       }
                     if(showlast)
                        delete_old_pos_div_lines();
                    }
                  ArrayPush(pos_div_lines, trendLine);
                  last_pos_div_lines = last_pos_div_lines + 1;
                  remove_last_pos_divs = true;
                 }

               if((y % 2) == 1)
                 {
                  if(old_neg_divs_can_be_removed)
                    {
                     old_neg_divs_can_be_removed = false;
                     if(! showlast && remove_last_neg_divs)
                       {
                        delete_last_neg_div_lines_label(last_neg_div_lines);
                        last_neg_div_lines = 0;
                       }
                     if(showlast)
                        delete_old_neg_div_lines();
                    }
                  ArrayPush(neg_div_lines, trendLine);
                  last_neg_div_lines = last_neg_div_lines + 1;
                  remove_last_neg_divs = true;
                 }

              }//includ

            // set variables for alerts
            if(y == 0)
               pos_reg_div_detected = true;
            if(y == 1)
               neg_reg_div_detected = true;
            if(y == 2)
               pos_hid_div_detected = true;
            if(y == 3)
               neg_hid_div_detected = true;

           }//if
        }//for
      // get text for labels
      if(div_type >= 0)
        {
         divergence_text_top    = divergence_text_top    + ((div_type % 2) == 1 ? (showindis != DonotShow ? indicators_name[x] + "," : "") : "");
         divergence_text_bottom = divergence_text_bottom + ((div_type % 2) == 0 ? (showindis != DonotShow ? indicators_name[x] + "," : "") : "");
        }
     }//for


   if(dnumdiv_top > 0)
      ExpSell[i] = MathMin(Low[i],Low[i+1]);
   if(dnumdiv_bottom > 0)
      ExpBuy[i] = MathMax(High[i],High[i+1]);

   if(showindis != DonotShow || shownum)
     {
      int bar_index=Bars-i-1;
      if(shownum && dnumdiv_top > 0)
         divergence_text_top = divergence_text_top + IntegerToString(dnumdiv_top);
      if(shownum && dnumdiv_bottom > 0)
         divergence_text_bottom = divergence_text_bottom + IntegerToString(dnumdiv_bottom);
      int size=12;
      if(divergence_text_top != "")
        {
         if(StringLen(divergence_text_top)>=15)
            size=11;
         if(showlast)
            delete_old_neg_div_labels();
         string LabelName="";
         LabelName=Basename+" NLabel "+IntegerToString(bar_index)+":"+divergence_text_top+"("+TimeToString(TimeCurrent())+")"+IntegerToString(ArraySize(neg_div_labels))
                   +"_"+IntegerToString(bar_index);

         if(TextCreate(0,LabelName,0,Time[i],MathMax(High[i],High[i+1]),divergence_text_top,top_label_col,ANCHOR_LEFT_LOWER,45,size))
            ArrayPush(neg_div_labels,LabelName);
        }

      if(divergence_text_bottom != "")
        {
         if(StringLen(divergence_text_bottom)>=15)
            size=11;
         if(showlast)
            delete_old_pos_div_labels();
         string LabelName="";
         LabelName=Basename+" PLabel "+IntegerToString(bar_index)+":"+divergence_text_bottom+"("+TimeToString(TimeCurrent())+")"+IntegerToString(ArraySize(pos_div_labels))
                   +"_"+IntegerToString(bar_index);

         if(TextCreate(0,LabelName,0,Time[i],MathMin(Low[i],Low[i+1]),divergence_text_bottom,bottom_label_col,ANCHOR_RIGHT_UPPER,45,size))
            ArrayPush(pos_div_labels,LabelName);

        }
     }


  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetBarIndex(string _LabelName)
  {
   string to_split=_LabelName;   // A string to split into substrings
   string sep="_";                // A separator as a character
   ushort u_sep;                  // The code of the separator character
   string result[];               // An array to get strings
//--- Get the separator code
   u_sep=StringGetCharacter(sep,0);
//--- Split the string to substrings
   int k=StringSplit(to_split,u_sep,result);

   string res = "";
   if(k>0)
     {
      res = result[ArraySize(result)-1];
     }
   
   
   if(res != "")
      return(StrToInteger(res));
   else
      return(-1);
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetBuySellBuf(string _labelname, bool bBuy)
  {
   
   if(bBuy)
     {
      int idx = GetBarIndex(_labelname);
      if(idx != -1)
        {
         int barshift = Bars - 1 - idx;
         ExpBuy[barshift] = EMPTY_VALUE;
        }

     }
   else
     {
      int idx = GetBarIndex(_labelname);
      if(idx != -1)
        {
         int barshift = Bars - 1 - idx;
         ExpSell[barshift] = EMPTY_VALUE;
        }

     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void delete_last_pos_div_lines_label(int n)
  {
   if(n>0 &&  ArraySize(pos_div_lines)>=n)
     {
      int asz=ArraySize(pos_div_lines);

      for(int i=1; i<=n+1; i++)
        {
         string trendLine=pos_div_lines[asz-i];
         ObjectDelete(trendLine);
         //  pos_div_lines[asz-i]="";
        }

      if(ArraySize(pos_div_labels)>1)
        {
         string labelName=pos_div_labels[ArraySize(pos_div_labels)-2];
         ObjectDelete(labelName);
         SetBuySellBuf(labelName, true);

         labelName=pos_div_labels[ArraySize(pos_div_labels)-1];
         ObjectDelete(labelName);
         SetBuySellBuf(labelName, true);

         // pos_div_labels[ArraySize(pos_div_labels)-2]="";
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void delete_last_neg_div_lines_label(int n)
  {
   if(n>0 &&  ArraySize(neg_div_lines)>=n)
     {
      int asz=ArraySize(neg_div_lines);

      for(int i=1; i<=n+1; i++)
        {
         string trendLine=neg_div_lines[asz-i];
         ObjectDelete(trendLine);
         // neg_div_lines[asz-i]="";
        }
      if(ArraySize(neg_div_labels)>1)
        {
         string labelName=neg_div_labels[ArraySize(neg_div_labels)-2];
         ObjectDelete(labelName);
         SetBuySellBuf(labelName, false);

         labelName=neg_div_labels[ArraySize(neg_div_labels)-2];
         ObjectDelete(labelName);
         SetBuySellBuf(labelName, false);

         // neg_div_labels[ArraySize(neg_div_labels)-2]="";


        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void delete_old_pos_div_lines()
  {
   if(ArraySize(pos_div_lines) > 0)
     {
      for(int i=0; i<ArraySize(pos_div_lines)-1; i++)
        {
         string trendLine=pos_div_lines[i];
         ObjectDelete(trendLine);
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void delete_old_neg_div_lines()
  {
   if(ArraySize(neg_div_lines) > 0)
     {
      for(int i=0; i<ArraySize(neg_div_lines)-1; i++)
        {
         string trendLine=neg_div_lines[i];
         ObjectDelete(trendLine);
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void delete_old_pos_div_labels()
  {
   if(ArraySize(pos_div_labels) > 0)
     {
      for(int i=0; i<ArraySize(pos_div_labels)-1; i++)
        {
         string trendLine=pos_div_labels[i];
         ObjectDelete(trendLine);
        }

      for(int i = Bars - 1; i >= 0; i--)
         ExpBuy[i] = EMPTY_VALUE;
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void delete_old_neg_div_labels()
  {
   if(ArraySize(neg_div_labels) > 0)
     {
      for(int i=0; i<ArraySize(neg_div_labels)-1; i++)
        {
         string trendLine=neg_div_labels[i];
         ObjectDelete(trendLine);
        }

      for(int i = Bars - 1; i >= 0; i--)
         ExpSell[i] = EMPTY_VALUE;
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UnShift(double &src[], double value)
  {
   double preVlaue=value;
   for(int i=0; i<ArraySize(src); i++)
     {
      double curVlaue=src[i];
      src[i]=preVlaue;
      preVlaue=curVlaue;
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UnShift(int &src[], int value)
  {
   int preVlaue=value;
   for(int i=0; i<ArraySize(src); i++)
     {
      int curVlaue=src[i];
      src[i]=preVlaue;
      preVlaue=curVlaue;
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double NZ(double value)
  {
   if(value==EMPTY_VALUE)
      return 0.0;
   else
      return value;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int NZ(int value)
  {
   if(value==EMPTY_VALUE)
      return 0;
   else
      return value;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int positive_regular_negative_hidden_divergence(double &src[], int cond, int pos)
  {
   int divlen = 0;

   if(dontconfirm || src[pos] > src[pos+1] || Close[pos] > Close[pos+1])
     {
      int startpoint = dontconfirm ? 0 : 1;
      for(int x=0; x<=maxpp - 1; x++)
        {
         int bar_index=Bars-pos-1;
         int len = bar_index - pl_positions[x] + prd;
         if(pl_positions[x]==0 || len>maxbars)
            break;
         if(len>5 && ((cond == 1 && src[pos+startpoint] > src[pos+len] && prscP[pos+startpoint] <NZ(pl_vals[x])) ||
                      (cond == 2 && src[pos+startpoint] < src[pos+len] && prscP[pos+startpoint] >NZ(ph_vals[x]))))
           {
            double slope1 = (src[pos+startpoint] - src[pos+len]) / (len - startpoint);
            double virtual_line1 = src[pos+startpoint] - slope1;
            double slope2 = (Close[pos+startpoint] - Close[pos+len]) / (len - startpoint);
            double virtual_line2 = Close[pos+startpoint] - slope2;
            bool arrived = true;

            for(int y=1 + startpoint; y<=len - 1; y++)
              {
               if(src[pos+y] < virtual_line1 ||NZ(Close[pos+y]) < virtual_line2)
                 {
                  arrived = false;
                  break;
                 }
               virtual_line1 = virtual_line1 - slope1;
               virtual_line2 = virtual_line2 - slope2;
              }
            if(arrived)
              {
               divlen=len;
               break;
              }
           }
        }
     }

   return divlen;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int negative_regular_positive_hidden_divergence(double &src[], int cond, int pos)
  {
   int divlen = 0;

   if(dontconfirm || src[pos] < src[pos+1] || Close[pos] < Close[pos+1])
     {
      int startpoint = dontconfirm ? 0 : 1;
      for(int x=0; x<=maxpp - 1; x++)
        {
         int bar_index=Bars-pos-1;
         int len = bar_index - ph_positions[x] + prd;
         if(ph_positions[x]==0 || len>maxbars)
            break;
         if(len>5 && ((cond == 1 && src[pos+startpoint] < src[pos+len] && prscN[pos+startpoint] >NZ(ph_vals[x])) ||
                      (cond == 2 && src[pos+startpoint] > src[pos+len] && prscN[pos+startpoint] <NZ(ph_vals[x]))))
           {
            double slope1 = (src[pos+startpoint] - src[pos+len]) / (len - startpoint);
            double virtual_line1 = src[pos+startpoint] - slope1;
            double slope2 = (Close[pos+startpoint] -NZ(Close[pos+len])) / (len - startpoint);
            double virtual_line2 = Close[pos+startpoint] - slope2;
            bool arrived = true;

            for(int y=1 + startpoint; y<=len - 1; y++)
              {
               if(src[pos+y] > virtual_line1 ||NZ(Close[pos+y]) > virtual_line2)
                 {
                  arrived = false;
                  break;
                 }
               virtual_line1 = virtual_line1 - slope1;
               virtual_line2 = virtual_line2 - slope2;
              }
            if(arrived)
              {
               divlen=len;
               break;
              }
           }
        }
     }
   return divlen;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void calculate_divs(bool cond, double &indicator[],int &calculate_divs_result[],int pos)
  {

   calculate_divs_result[0]= cond && (searchdiv == Regular || searchdiv == R_H) ? positive_regular_negative_hidden_divergence(indicator, 1, pos) : 0;

   calculate_divs_result[1]= cond && (searchdiv == Regular || searchdiv == R_H) ? negative_regular_positive_hidden_divergence(indicator, 1, pos) : 0;

   calculate_divs_result[2]= cond && (searchdiv == Hidden || searchdiv == R_H) ? negative_regular_positive_hidden_divergence(indicator, 2, pos) : 0;

   calculate_divs_result[3]= cond && (searchdiv == Hidden || searchdiv == R_H) ? positive_regular_negative_hidden_divergence(indicator, 2, pos) : 0;
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Sign(double value)
  {
   if(value==0)
      return 0;
   if(value>0)
      return  1;
   return-1;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Stoch(int length, int position)
  {
   double result=0.0;
   int lowest=iLowest(_Symbol,0,MODE_LOW,length,position);
   int highest=iHighest(_Symbol,0,MODE_HIGH,length,position);
   result=100*(Close[position]-Low[lowest])/(High[highest]-Low[lowest]);

   return result;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Cum(double &values[])
  {
   double sum=0.0;
   for(int i=0; i<ArraySize(values); i++)
      sum+=values[i];

   return sum;
  }

//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double SimpleMA(const int position,const int period,const double &price[])
  {
//---
   double result=0.0;
//--- check position
   if(period>0)
     {
      //--- calculate value
      for(int i=0; i<period; i++)
         if(price[position+i]!=EMPTY_VALUE)
            result+=price[position+i];
      result/=period;
     }
//---
   return(result);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double VolumnWeightMA(const int position,const int period,const double &price[])
  {
   double result = 0.0;
   double vwsum = 0.0, vsum = 0.0;
   if(period > 0)
     {
      for(int i = 0; i<period; i++)
        {
         long volume = iVolume(_Symbol,_Period,position+i);
         vwsum += price[position+i] * volume;
         vsum += (double)volume;
        }
     }

   if(vsum == 0)
      result = 0;
   else
      result = vwsum/vsum;
   return(result);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PivotHigh(const double &buffer[], int left, int right, int index)
  {
   double high = buffer[index + right];
   int iCount = left + right + 1;
   for(int i = 0; i <iCount; i++)
     {
      if(i == right)
         continue;
      if(high < buffer[index + i])
         return(DBL_MAX);
     }

   return(high);
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PivotLow(const double &buffer[], int left, int right, int index)
  {
   double low = buffer[index + right];
   int iCount = left + right + 1;
   for(int i = 0; i <iCount; i++)
     {
      if(i == right)
         continue;
      if(low > buffer[index + i])
         return(DBL_MAX);
     }

   return(low);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Creating Text object                                             |
//+------------------------------------------------------------------+
bool TextCreate(const long              chart_ID=0,               // chart's ID
                const string            name="Text",              // object name
                const int               sub_window=0,             // subwindow index
                datetime                time=0,                   // anchor point time
                double                  price=0,                  // anchor point price
                const string            text="Text",              // the text itself
                const color             clr=clrRed,               // color
                const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // anchor type
                const double            angle=0.0,                // text slope
                const int               font_size=12,             // font size
                const string            font="Arial",             // font
                const bool              back=false,               // in the background
                const bool              selection=false,          // highlight to move
                const bool              hidden=true,              // hidden in the object list
                const long              z_order=0)                // priority for mouse click
  {
//--- set anchor point coordinates if they are not set

//--- reset the error value
   ResetLastError();
//--- create Text object
   if(!ObjectCreate(chart_ID,name,OBJ_TEXT,sub_window,time,price))
     {
      Print(__FUNCTION__,
            ": failed to create \"Text\" object! Error code = ",GetLastError());
      return(false);
     }
//--- set the text
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- set text font
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- set font size
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- set the slope angle of the text
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- set anchor type
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- set color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the object by mouse
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectsDeleteAll(0,Basename);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Create a trend line by the given coordinates                     |
//+------------------------------------------------------------------+
bool TrendCreate(const long            chart_ID=0,        // chart's ID
                 const string          name="TrendLine",  // line name
                 const int             sub_window=0,      // subwindow index
                 datetime              time1=0,           // first point time
                 double                price1=0,          // first point price
                 datetime              time2=0,           // second point time
                 double                price2=0,          // second point price
                 const color           clr=clrRed,        // line color
                 const ENUM_LINE_STYLE style=STYLE_SOLID, // line style
                 const int             width=1,           // line width
                 const bool            back=false,        // in the background
                 const bool            selection=false,    // highlight to move
                 const bool            ray_right=false,   // line's continuation to the right
                 const bool            hidden=true,       // hidden in the object list
                 const long            z_order=0)         // priority for mouse click
  {
//--- set anchor points' coordinates if they are not set
// ChangeTrendEmptyPoints(time1,price1,time2,price2);
//--- reset the error value
   ResetLastError();
//--- create a trend line by the given coordinates
   if(!ObjectCreate(chart_ID,name,OBJ_TREND,sub_window,time1,price1,time2,price2))
     {
      Print(__FUNCTION__,
            ": failed to create a trend line! Error code = ",GetLastError());
      return(false);
     }
//--- set line color
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set line display style
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//--- set line width
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the line by mouse
//--- when creating a graphical object using ObjectCreate function, the object cannot be
//--- highlighted and moved by default. Inside this method, selection parameter
//--- is true by default making it possible to highlight and move the object
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- enable (true) or disable (false) the mode of continuation of the line's display to the right
   ObjectSetInteger(chart_ID,name,OBJPROP_RAY_RIGHT,ray_right);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Price(ENUM_APPLIED_PRICE InpSrc,int shift)
  {
//----
   double res;
//----
   switch(InpSrc)
     {
      case PRICE_OPEN:
         res=Open[shift];
         break;
      case PRICE_HIGH:
         res=High[shift];
         break;
      case PRICE_LOW:
         res=Low[shift];
         break;
      case PRICE_MEDIAN:
         res=(High[shift]+Low[shift])/2.0;
         break;
      case PRICE_TYPICAL:
         res=(High[shift]+Low[shift]+Close[shift])/3.0;
         break;
      case PRICE_WEIGHTED:
         res=(High[shift]+Low[shift]+2*Close[shift])/4.0;
         break;
      case PRICE_CLOSE:
      default:
         res=Close[shift];
         break;
     }
   return(res);
  }
//+------------------------------------------------------------------+
